cd "/Users/bodet/Documents/Bodet UBC/POLI574/Data/"

use Party2.dta, clear   /*Progressive-Conservative Party of Canada*/

*Level-1: Invidivual voters
*Level-2: Ridings AND/OR Day of campaign

sort day idnum   /* let's start with level2=riding and local chances */
xtset day idnum   /* though idnum is not a time variable! */
*
xtsum nationalchances /* some descriptive stats */

**********************
*p.64 - Three options*
**********************

xtmixed localchances || day: , mle /* same results though xtmixed is slower */

************************************************
*p.91 - Random-intercept models with covariates*
************************************************

xtsum idf soph poll noise /* some descriptive stats: what's wrong? */

**************************************************
*p.98 - Again... Three options... but we pick one*
**************************************************

xtmixed nationalchances idf soph poll noise || day: , variance mle /* same results though xtmixed is slower */

**********************
*p.122 - Hausman Test*
**********************

xtreg nationalchances idf soph poll noise, fe   /* a series of fixed effects */
est store fixed
xtreg nationalchances idf soph poll noise, re
est store random

hausman fixed random

/*Yeah! RE is the correct specification*/

****************************************************
*p.142 - Separate linear regression for each riding*
****************************************************

reg nationalchances idf soph if day==26   /*why not "robust"? */

egen num=count(nationalchances), by(day) /* we want enough obs to run the ols model */

statsby intercept=_b[_cons] slope1=_b[idf] slope2=_b[soph], by(day) saving(OLSData, replace): ///
regress nationalchances idf soph if num>20   /* let's isolate soph for now */
*
sort day
merge day using OLSData
drop _merge

hist slope1, xtitle(b_idf) normal
hist slope2, xtitle(b_idf) normal

twoway scatter slope1 day, xtitle(day) ytitle(b_idf)
twoway scatter slope2 day, xtitle(day) ytitle(b_soph)

twoway scatter slope1 poll, xtitle(last poll) ytitle(b_idf)
twoway scatter slope2 poll, xtitle(last poll) ytitle(b_soph)

gen prediction=inter + slope1*idf + slope2*soph
gen rez=nationalchances - prediction
egen sd_rez=sd(rez), by(day)

hist rez, xtitle(Residuals) normal
twoway scatter rez day, xtitle(day of campaign) ytitle(residuals)

hist sd_rez, xtitle(Residuals) normal
twoway scatter sd_rez day, xtitle(day of campaign) ytitle(sd of residuals)
twoway lowess sd_rez day, xtitle(day of campaign) ytitle(sd of residuals)
